from direct.gui.DirectGui import *
from OptionsMenu import OptionsMenu

from direct.showbase.DirectObject import DirectObject
from direct.task import Task


#TODO: pass pause to game class 
class InGameMenu(DirectObject):
    def __init__(self, parent, params):
        self.active = False
        self.visible = False
        
        self.params = params
        
        self.optionsMenu = OptionsMenu(self, self.params);
        self.parent = parent
        
        self.mainFrame = DirectFrame(frameColor=(0,0,0,1) , frameSize=(-0.2,0.2,0.9,-0.2 ))
        self.cont = DirectButton(parent = self.mainFrame, text = ("continue"), pos = (0,0,0.8),scale=.05,command=self.showHide)
        self.save = DirectButton(parent = self.mainFrame, text = ("save"), pos = (0,0,0.6),scale=.05,command=parent.save)    
        self.load = DirectButton(parent = self.mainFrame, text = ("load"), pos = (0,0,0.4),scale=.05,command=parent.load)
        self.options = DirectButton(parent = self.mainFrame, text = ("Options"), pos = (0,0,0.2),scale=.05,command=self.showOptions)
        self.exit = DirectButton(parent = self.mainFrame, text = ("Exit"), pos = (0,0,0),scale=.05,command=parent.gotoMain)
        
        self.accept( "escape", self.showHide )
        self.hide()

    def activate(self):
        self.active = True
    
    def deactivate(self):
        self.active = False
    
    def hide(self):
        self.mainFrame.hide()
        self.visible = False
        
    def show(self):
        self.mainFrame.show()
        self.visible = True
    
    #TODO: somehow to pause game
    def showHide(self):
        if not self.active:
            return
        if self.visible:
            self.hide()
        else:
            self.show()
    
    def showOptions(self):
        self.hide()
        self.optionsMenu.show()
    
    def __del__(self):
        self.cont.destroy()
        self.save.destroy()
        self.load.destroy()
        self.options.destroy()
        self.exit.destroy()
        self.mainFrame.destroy()
        self.optionsMenu.__del__();